close all; clc;

%% Ouverture du port srie

SerialCOM = Open(); % A commenter aprs la 1re excution

%% Cration de l'objet vido

vid=videoinput('winvideo',1);
set(vid,'ReturnedColorSpace','RGB');

%% Dtection de la composante rouge dans l'image

while 1
    
    % Obtenir l'image actuelle
    imm=getsnapshot(vid); 
    im_rgb=imresize(imm,0.5); % Rduction de 50%
    
    % Rcuprer les composantes R, G et B
    im_gray=rgb2gray(im_rgb);
    im_R=im_rgb(:,:,1);im_r=imsubtract(im_R,im_gray);
    im_G=im_rgb(:,:,2);im_g=imsubtract(im_G,im_gray);
    im_B=im_rgb(:,:,3);im_b=imsubtract(im_B,im_gray);
    
    %     subplot(221); imshow(im_rgb); title('Image RGB');
    %     subplot(222); imshow(im_r); title('R Aprs soustraction');
    %     subplot(223); imshow(im_g); title('G Aprs soustraction');
    %     subplot(224); imshow(im_b); title('B Aprs soustraction');
    
    %% Seuillage de l'image (binrisation)
    
    val_r=abs(max(double(im_r(:)))-20); seuil_r=val_r/255;  % Seuil de l'image (variable)
    val_g=abs(max(double(im_g(:)))-20); seuil_g=val_g/255;
    val_b=abs(max(double(im_b(:)))-20); seuil_b=val_b/255;
    
    Seuil_min=50;     % Seuil minimal fixe ( Problme du  l'absence de la couleur cible)
    im_bw=im2bw(im_r,seuil_r);im_bw1=im_bw & (im_r >Seuil_min);
    se=strel('disk',10); im_out_r=imclose(im_bw1,se);
    
    im_bw=im2bw(im_g,seuil_g);im_bw1=im_bw & (im_g >(Seuil_min/5));
    im_out_g=imclose(im_bw1,se);
    
    im_bw=im2bw(im_b,seuil_b);im_bw1=im_bw & (im_b >Seuil_min);
    im_out_b=imclose(im_bw1,se);
    
    %% Activation des LEDs (0-7)
    
    % Nombre des pixels de la couleur R, G, B
    taille_r=length(find(im_out_r(:)==1));
    taille_g=length(find(im_out_g(:)==1));
    taille_b=length(find(im_out_b(:)==1));
    
    % Activation de la LED par le nombre de pixels
    Seuil_detec=100;
    LED_r=double(taille_r>Seuil_detec);
    LED_g=double(taille_g>Seuil_detec);
    LED_b=double(taille_b>Seuil_detec);
    LED=[LED_r LED_g LED_b];
    
    %% Affichage
    
    subplot(221); imshow(im_rgb);   title('RGB');
    subplot(222); imshow(im_out_r); title('R');
    subplot(223); imshow(im_out_g); title('G');
    subplot(224); imshow(im_out_b); title('B');
    
    %% Transmission  l'Arduino
    
    % Conversion BCD => Dcimal
    LED_val =LED_r*4+ LED_g*2 + LED_b % RGB
    
    % Transfert de la valeur
    fprintf(SerialCOM,'%d\n',LED_val);
    
end

%% Port Delete (Previous port if exist)

Delete(SerialCOM); % A excuter seule pour librer le port


